from simNetPy import *
import os

def first_fit_algorithm(src: int, dst: int, b: BitRate, c: Connection, n: Network, path, action):
    numberOfSlots = b.getNumberofSlots(0)
    link_ids = path[src][dst][0]
    general_link = []
    
    for _ in range(n.getLink(0).getSlots()):
        general_link.append(False)
    for link in link_ids:
        link = n.getLink(link.id)

        '''
        for i in ["C","S","L","E"]:
            print("Band: ", i)
            link.band = i
            print(link.slots)        
        '''

        for slot in range(link.getSlots()):
            general_link[slot] = general_link[slot] or link.getSlot(slot)
    currentNumberSlots = 0
    currentSlotIndex = 0

    for j in range(len(general_link)):
        if not general_link[j]:
            currentNumberSlots += 1
        else:
            currentNumberSlots = 0
            currentSlotIndex = j + 1
        if currentNumberSlots == numberOfSlots:
            for k in link_ids:
                c.addLink(
                    k, fromSlot=currentSlotIndex, toSlot=currentSlotIndex+currentNumberSlots)
            return Controller.Status.Allocated, c
    return Controller.Status.Not_Allocated, c


absolutepath = os.path.abspath(__file__)
fileDirectory = os.path.dirname(absolutepath)

sim = Simulator(fileDirectory + "/NSFNet_4_bands.json", fileDirectory + "/routes.json")

sim.setGoalConnections(10000) 
sim.setAllocator(first_fit_algorithm)

sim.init()
sim.run()
